/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplateMessageComponent type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplateMessageComponent{}

// WhatsAppTemplateMessageComponent struct for WhatsAppTemplateMessageComponent
type WhatsAppTemplateMessageComponent struct {
	Type string `json:"type"`
	// For buttons only
	SubType *string `json:"sub_type,omitempty"`
	// For buttons only
	Index *string `json:"index,omitempty"`
	Parameters []WhatsAppTemplateMessageComponentParametersInner `json:"parameters,omitempty"`
	Cards []WhatsAppTemplateMessageCard `json:"cards,omitempty"`
}

// NewWhatsAppTemplateMessageComponent instantiates a new WhatsAppTemplateMessageComponent object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplateMessageComponent(type_ string) *WhatsAppTemplateMessageComponent {
	this := WhatsAppTemplateMessageComponent{}
	this.Type = type_
	return &this
}

// NewWhatsAppTemplateMessageComponentWithDefaults instantiates a new WhatsAppTemplateMessageComponent object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateMessageComponentWithDefaults() *WhatsAppTemplateMessageComponent {
	this := WhatsAppTemplateMessageComponent{}
	return &this
}

// GetType returns the Type field value
func (o *WhatsAppTemplateMessageComponent) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponent) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *WhatsAppTemplateMessageComponent) SetType(v string) {
	o.Type = v
}

// GetSubType returns the SubType field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponent) GetSubType() string {
	if o == nil || IsNil(o.SubType) {
		var ret string
		return ret
	}
	return *o.SubType
}

// GetSubTypeOk returns a tuple with the SubType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponent) GetSubTypeOk() (*string, bool) {
	if o == nil || IsNil(o.SubType) {
		return nil, false
	}
	return o.SubType, true
}

// HasSubType returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponent) HasSubType() bool {
	if o != nil && !IsNil(o.SubType) {
		return true
	}

	return false
}

// SetSubType gets a reference to the given string and assigns it to the SubType field.
func (o *WhatsAppTemplateMessageComponent) SetSubType(v string) {
	o.SubType = &v
}

// GetIndex returns the Index field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponent) GetIndex() string {
	if o == nil || IsNil(o.Index) {
		var ret string
		return ret
	}
	return *o.Index
}

// GetIndexOk returns a tuple with the Index field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponent) GetIndexOk() (*string, bool) {
	if o == nil || IsNil(o.Index) {
		return nil, false
	}
	return o.Index, true
}

// HasIndex returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponent) HasIndex() bool {
	if o != nil && !IsNil(o.Index) {
		return true
	}

	return false
}

// SetIndex gets a reference to the given string and assigns it to the Index field.
func (o *WhatsAppTemplateMessageComponent) SetIndex(v string) {
	o.Index = &v
}

// GetParameters returns the Parameters field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponent) GetParameters() []WhatsAppTemplateMessageComponentParametersInner {
	if o == nil || IsNil(o.Parameters) {
		var ret []WhatsAppTemplateMessageComponentParametersInner
		return ret
	}
	return o.Parameters
}

// GetParametersOk returns a tuple with the Parameters field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponent) GetParametersOk() ([]WhatsAppTemplateMessageComponentParametersInner, bool) {
	if o == nil || IsNil(o.Parameters) {
		return nil, false
	}
	return o.Parameters, true
}

// HasParameters returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponent) HasParameters() bool {
	if o != nil && !IsNil(o.Parameters) {
		return true
	}

	return false
}

// SetParameters gets a reference to the given []WhatsAppTemplateMessageComponentParametersInner and assigns it to the Parameters field.
func (o *WhatsAppTemplateMessageComponent) SetParameters(v []WhatsAppTemplateMessageComponentParametersInner) {
	o.Parameters = v
}

// GetCards returns the Cards field value if set, zero value otherwise.
func (o *WhatsAppTemplateMessageComponent) GetCards() []WhatsAppTemplateMessageCard {
	if o == nil || IsNil(o.Cards) {
		var ret []WhatsAppTemplateMessageCard
		return ret
	}
	return o.Cards
}

// GetCardsOk returns a tuple with the Cards field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageComponent) GetCardsOk() ([]WhatsAppTemplateMessageCard, bool) {
	if o == nil || IsNil(o.Cards) {
		return nil, false
	}
	return o.Cards, true
}

// HasCards returns a boolean if a field has been set.
func (o *WhatsAppTemplateMessageComponent) HasCards() bool {
	if o != nil && !IsNil(o.Cards) {
		return true
	}

	return false
}

// SetCards gets a reference to the given []WhatsAppTemplateMessageCard and assigns it to the Cards field.
func (o *WhatsAppTemplateMessageComponent) SetCards(v []WhatsAppTemplateMessageCard) {
	o.Cards = v
}

func (o WhatsAppTemplateMessageComponent) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplateMessageComponent) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if !IsNil(o.SubType) {
		toSerialize["sub_type"] = o.SubType
	}
	if !IsNil(o.Index) {
		toSerialize["index"] = o.Index
	}
	if !IsNil(o.Parameters) {
		toSerialize["parameters"] = o.Parameters
	}
	if !IsNil(o.Cards) {
		toSerialize["cards"] = o.Cards
	}
	return toSerialize, nil
}

type NullableWhatsAppTemplateMessageComponent struct {
	value *WhatsAppTemplateMessageComponent
	isSet bool
}

func (v NullableWhatsAppTemplateMessageComponent) Get() *WhatsAppTemplateMessageComponent {
	return v.value
}

func (v *NullableWhatsAppTemplateMessageComponent) Set(val *WhatsAppTemplateMessageComponent) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateMessageComponent) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateMessageComponent) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateMessageComponent(val *WhatsAppTemplateMessageComponent) *NullableWhatsAppTemplateMessageComponent {
	return &NullableWhatsAppTemplateMessageComponent{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateMessageComponent) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateMessageComponent) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


